package ffp_examples;

/*
 * basic2d.java
 * This program demonstrates simple 2d graphics in FFP.
 */
public class basic2d extends DemoBase {

	public static void main(String[] args) {
		new basic2d().init(EUT_RGB);
	}

	public static void reshape(int w, int h) {
		ffp.ffpViewport(0, 0, w, h);
		create_projection(w, h);
	}

	private static void create_projection(int w, int h) {
		ffp.ffpMatrixMode(FFP_PROJECTION);
		ffp.ffpLoadIdentity();
		if (w <= h) {
			aux.auxOrtho2D(-1.0f, 1.0f, -1.0f, 1.0f * h / w);
		} else {
			aux.auxOrtho2D(-1.0f, 1.0f * w / h, -1.0f, 1.0f);
		}
		ffp.ffpMatrixMode(FFP_MODELVIEW);
	}

	@Override
	public void dbInit(int width, int height) {
		reshape(width, height);
	}

	@Override
	public void dbUpdate() {

	}

	@Override
	public void dbRender() {
		ffp.ffpClear(FFP_VIDEO_BUFFER);

		ffp.ffpBegin(FFP_QUADS);
		ffp.ffpColor3f(1.0f, 0.0f, 0.0f);
		ffp.ffpVertex2f(-0.8f, 0.1f);
		ffp.ffpVertex2f(-0.2f, 0.1f);
		ffp.ffpVertex2f(-0.2f, 0.7f);
		ffp.ffpVertex2f(-0.8f, 0.7f);

		ffp.ffpColor3f(0.0f, 1.0f, 0.0f);
		ffp.ffpVertex2f(-0.7f, -0.6f);
		ffp.ffpVertex2f(-0.1f, -0.6f);
		ffp.ffpVertex2f(-0.1f, 0.0f);
		ffp.ffpVertex2f(-0.7f, 0.0f);

		ffp.ffpColor1f(0.2f);
		ffp.ffpVertex2f(-0.9f, -0.7f);
		ffp.ffpColor1f(1.0f);
		ffp.ffpVertex2f(-0.5f, -0.7f);
		ffp.ffpColor1f(0.2f);
		ffp.ffpVertex2f(-0.5f, -0.3f);
		ffp.ffpColor1f(1.0f);
		ffp.ffpVertex2f(-0.9f, -0.3f);
		ffp.ffpEnd();

		ffp.ffpBegin(FFP_TRIANGLES);
		ffp.ffpColor3f(0.0f, 0.0f, 1.0f);
		ffp.ffpVertex2f(0.1f, -0.6f);
		ffp.ffpVertex2f(0.7f, -0.6f);
		ffp.ffpVertex2f(0.4f, -0.1f);

		ffp.ffpColor3f(1.0f, 0.0f, 0.0f);
		ffp.ffpVertex2f(0.3f, -0.4f);
		ffp.ffpColor3f(0.0f, 1.0f, 0.0f);
		ffp.ffpVertex2f(0.9f, -0.4f);
		ffp.ffpColor3f(0.0f, 0.0f, 1.0f);
		ffp.ffpVertex2f(0.6f, -0.9f);
		ffp.ffpEnd();

		ffp.ffpBegin(FFP_LINE_LOOP);
		ffp.ffpColor3f(1.0f, 1.0f, 0.0f);
		ffp.ffpVertex2f(0.4f, 0.2f);
		ffp.ffpVertex2f(0.6f, 0.2f);
		ffp.ffpVertex2f(0.7f, 0.4f);
		ffp.ffpVertex2f(0.6f, 0.6f);
		ffp.ffpVertex2f(0.4f, 0.6f);
		ffp.ffpVertex2f(0.3f, 0.4f);
		ffp.ffpEnd();

		ffp.ffpFlush(FFP_MULTI_THREADED);
	}

}
