package ffp_examples;

/*
 *  fog.java
 *  This program demonstrates fogging.
 *  Left click to bring the scene closer,
 *  and right click to push the scene further.
 */
public class fog extends DemoBase {

	static float light_ambient[] = { 0.0f, 0.0f, 0.0f, 1.0f };
	static float light_diffuse[] = { 1.0f, 0.0f, 0.0f, 1.0f };
	static float light_specular[] = { 1.0f, 1.0f, 1.0f, 1.0f };
	/* light_position is NOT default value */
	static float light_position[] = { 1.0f, 1.0f, 1.0f, 0.0f };

	static float translation = -10.0f;

	public static void main(String[] args) {
		new fog().init(EUT_RGB);
	}

	public static void reshape(int w, int h) {
		ffp.ffpViewport(0, 0, w, h);
		create_projection(w, h);
	}

	private static void create_projection(int w, int h) {
		ffp.ffpMatrixMode(FFP_PROJECTION);
		ffp.ffpLoadIdentity();
		aux.auxPerspective(60.0f, (float) w / (float) h, 1, 10);
		ffp.ffpMatrixMode(FFP_MODELVIEW);
	}

	@Override
	public void dbInit(int width, int height) {
		reshape(width, height);
		ffp.ffpClearColor(0xaa, 0xaa, 0xaa);
		ffp.ffpShadeModel(FFP_SMOOTH);
		ffp.ffpEnable(FFP_LIGHTING);
		ffp.ffpEnableLight(0);
		ffp.ffpEnable(FFP_DEPTH_TEST);
		ffp.ffpEnable(FFP_FOG);
		ffp.ffpFogColor(0xaa, 0xaa, 0xaa);

		ffp.ffpLightfv(0, FFP_AMBIENT, light_ambient);
		ffp.ffpLightfv(0, FFP_DIFFUSE, light_diffuse);
		ffp.ffpLightfv(0, FFP_SPECULAR, light_specular);
		ffp.ffpLightfv(0, FFP_POSITION, light_position);
	}

	@Override
	public void dbUpdate() {
		if (mouseLeftButtonActive()) {
			translation += 0.2f;
			if (translation > -4) {
				translation = -4;
			}
		}
		if (mouseRightButtonActive()) {
			translation -= 0.2f;
			if (translation < -15) {
				translation = -15;
			}
		}
	}

	@Override
	public void dbRender() {
		ffp.ffpClear(FFP_VIDEO_BUFFER | FFP_DEPTH_BUFFER);
		ffp.ffpPushMatrix();
		ffp.ffpTranslatef(0, 0, translation);
		ffp.ffpPushMatrix();
		ffp.ffpRotatef(20.0f, 1.0f, 0.0f, 0.0f);

		ffp.ffpPushMatrix();
		ffp.ffpTranslatef(-0.75f, 0.5f, 0.0f);
		ffp.ffpRotatef(90.0f, 1.0f, 0.0f, 0.0f);
		aux.auxSolidTorus(0.275f, 0.85f, 15, 15);
		ffp.ffpPopMatrix();

		ffp.ffpPushMatrix();
		ffp.ffpTranslatef(-0.75f, -0.5f, 0.0f);
		ffp.ffpRotatef(270.0f, 1.0f, 0.0f, 0.0f);
		aux.auxSolidCone(1.0f, 2.0f, 15, 15);
		ffp.ffpPopMatrix();

		ffp.ffpPushMatrix();
		ffp.ffpTranslatef(0.75f, 0.0f, -1.0f);
		aux.auxSolidSphere(1.0f, 15, 15);
		ffp.ffpPopMatrix();

		ffp.ffpPopMatrix();
		ffp.ffpPopMatrix();
		ffp.ffpFlush(FFP_MULTI_THREADED);
	}

}
