package ffp_examples;

/*
 *  polys.java
 *  This program demonstrates polygon stippling.
 */
public class polys extends DemoBase {

	public static void main(String[] args) {
		new polys().init(EUT_RGB | EUT_NOT_RESIZABLE);
	}

	static short[] fly = { //n
			0x00, 0x00, 0x00, 0x00, //n
			0x00, 0x00, 0x00, 0x00, //n
			0x03, 0x80, 0x01, 0xC0, //n
			0x06, 0xC0, 0x03, 0x60, //n
			0x04, 0x60, 0x06, 0x20, //n
			0x04, 0x30, 0x0C, 0x20, //n
			0x04, 0x18, 0x18, 0x20, //n
			0x04, 0x0C, 0x30, 0x20, //n
			0x04, 0x06, 0x60, 0x20, //n
			0x44, 0x03, 0xC0, 0x22, //n
			0x44, 0x01, 0x80, 0x22, //n
			0x44, 0x01, 0x80, 0x22, //n
			0x44, 0x01, 0x80, 0x22, //n
			0x44, 0x01, 0x80, 0x22, //n
			0x44, 0x01, 0x80, 0x22, //n
			0x44, 0x01, 0x80, 0x22, //n
			0x66, 0x01, 0x80, 0x66, //n
			0x33, 0x01, 0x80, 0xCC, //n
			0x19, 0x81, 0x81, 0x98, //n
			0x0C, 0xC1, 0x83, 0x30, //n
			0x07, 0xe1, 0x87, 0xe0, //n
			0x03, 0x3f, 0xfc, 0xc0, //n
			0x03, 0x31, 0x8c, 0xc0, //n
			0x03, 0x33, 0xcc, 0xc0, //n
			0x06, 0x64, 0x26, 0x60, //n
			0x0c, 0xcc, 0x33, 0x30, //n
			0x18, 0xcc, 0x33, 0x18, //n
			0x10, 0xc4, 0x23, 0x08, //n
			0x10, 0x63, 0xC6, 0x08, //n
			0x10, 0x30, 0x0c, 0x08, //n
			0x10, 0x18, 0x18, 0x08, //n
			0x10, 0x00, 0x00, 0x08 //n
	};

	static short[] halftone = { //n
			0xAA, 0xAA, 0xAA, 0xAA, //n
			0x55, 0x55, 0x55, 0x55, //n
			0xAA, 0xAA, 0xAA, 0xAA, //n
			0x55, 0x55, 0x55, 0x55, //n
			0xAA, 0xAA, 0xAA, 0xAA, //n
			0x55, 0x55, 0x55, 0x55, //n
			0xAA, 0xAA, 0xAA, 0xAA, //n
			0x55, 0x55, 0x55, 0x55, //n
			0xAA, 0xAA, 0xAA, 0xAA, //n
			0x55, 0x55, 0x55, 0x55, //n
			0xAA, 0xAA, 0xAA, 0xAA, //n
			0x55, 0x55, 0x55, 0x55, //n
			0xAA, 0xAA, 0xAA, 0xAA, //n
			0x55, 0x55, 0x55, 0x55, //n
			0xAA, 0xAA, 0xAA, 0xAA, //n
			0x55, 0x55, 0x55, 0x55, //n
			0xAA, 0xAA, 0xAA, 0xAA, //n
			0x55, 0x55, 0x55, 0x55, //n
			0xAA, 0xAA, 0xAA, 0xAA, //n
			0x55, 0x55, 0x55, 0x55, //n
			0xAA, 0xAA, 0xAA, 0xAA, //n
			0x55, 0x55, 0x55, 0x55, //n
			0xAA, 0xAA, 0xAA, 0xAA, //n
			0x55, 0x55, 0x55, 0x55, //n
			0xAA, 0xAA, 0xAA, 0xAA, //n
			0x55, 0x55, 0x55, 0x55, //n
			0xAA, 0xAA, 0xAA, 0xAA, //n
			0x55, 0x55, 0x55, 0x55, //n
			0xAA, 0xAA, 0xAA, 0xAA, //n
			0x55, 0x55, 0x55, 0x55, //n
			0xAA, 0xAA, 0xAA, 0xAA, //n
			0x55, 0x55, 0x55, 0x55 //n
	};

	private static void create_projection(int w, int h) {
		ffp.ffpMatrixMode(FFP_PROJECTION);
		ffp.ffpLoadIdentity();
		ffp.ffpOrtho(0.0f, w, 0.0f, h, -1.0f, 1.0f);
		ffp.ffpMatrixMode(FFP_MODELVIEW);
		ffp.ffpLoadIdentity();
	}

	@Override
	public void dbInit(int width, int height) {
		create_projection(350, 150);
		ffp.ffpShadeModel(FFP_FLAT);
	}

	@Override
	public void dbUpdate() {

	}

	@Override
	public void dbRender() {
		ffp.ffpClear(FFP_VIDEO_BUFFER);
		ffp.ffpColor3f(1.0f, 1.0f, 1.0f);

		/* draw one solid, unstippled rectangle, */
		/* then two stippled rectangles	         */
		ffp.ffpRecti(25, 25, 125, 125);
		ffp.ffpEnable(FFP_POLYGON_STIPPLE);
		ffp.ffpPolygonStipple(fly);
		ffp.ffpRecti(125, 25, 225, 125);
		ffp.ffpPolygonStipple(halftone);
		ffp.ffpRecti(225, 25, 325, 125);
		ffp.ffpDisable(FFP_POLYGON_STIPPLE);

		ffp.ffpFlush(FFP_MULTI_THREADED);
	}

}
