package ffp_examples;

/*
 * smooth.java
 * This program demonstrates smooth shading.
 * A smooth shaded polygon is drawn in a 2-D projection.
 */
public class smooth extends DemoBase {

	public static void main(String[] args) {
		new smooth().init(EUT_RGB);
	}

	private static void create_projection(int w, int h) {
		ffp.ffpMatrixMode(FFP_PROJECTION);
		ffp.ffpLoadIdentity();
		if (w <= h) {
			aux.auxOrtho2D(0.0f, 30.0f, 0.0f, 30.0f * h / w);
		} else {
			aux.auxOrtho2D(0.0f, 30.0f * w / h, 0.0f, 30.0f);
		}
		ffp.ffpMatrixMode(FFP_MODELVIEW);
	}

	@Override
	public void dbInit(int width, int height) {
		create_projection(width, height);
	}

	@Override
	public void dbUpdate() {

	}

	@Override
	public void dbRender() {
		ffp.ffpClear(FFP_VIDEO_BUFFER);
		ffp.ffpBegin(FFP_TRIANGLES);
		ffp.ffpColor3ub(255, 0, 0);
		ffp.ffpVertex2f(5.0f, 5.0f);
		ffp.ffpColor3ub(0, 255, 0);
		ffp.ffpVertex2f(25.0f, 5.0f);
		ffp.ffpColor3ub(0, 0, 255);
		ffp.ffpVertex2f(5.0f, 25.0f);
		ffp.ffpEnd();
		ffp.ffpFlush(FFP_MULTI_THREADED);
	}

}
